/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2018 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : Config_TPU4.c
* Version      : 1.5.0
* Device(s)    : R5F565NEDxFP
* Description  : This file implements device driver for Config_TPU4.
* Creation Date: 2019-05-29
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */

/* The src/FreeRTOS/Demo/Full_Demo/IntQueueTimer.c has its own implementation for the TPU4. */
#if 0

/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "Config_TPU4.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: R_Config_TPU4_Create
* Description  : This function initializes the TPU4 channel
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

void R_Config_TPU4_Create(void)
{
    /* Release TPU channel 4 from stop state */
    MSTP(TPU4) = 0U;

    /* Stop TPU channel 4 counter */
    TPUA.TSTR.BIT.CST4 = 0U;

    /* Set TGI4A interrupt priority level */
    ICU.SLIBR160.BYTE = 0x21U;
    IPR(PERIB, INTB160) = _00_TPU_PRIORITY_LEVEL0;

    /* TPU channel 4 is used as normal mode */
    TPUA.TSYR.BIT.SYNC4 = 0U;
    TPU4.TCR.BYTE = _00_TPU_PCLK_1 | _00_TPU_CKCL_DIS;
    TPU4.TIER.BYTE |= _01_TPU_TGIEA_ENABLE | _00_TPU_TGIEB_DISABLE | _00_TPU_TCIEV_DISABLE | _00_TPU_TTGE_DISABLE | 
                      _40_TPU_TIER_DEFAULT;
    TPU4.TIOR.BYTE = _00_TPU_IOA_DISABLE | _00_TPU_IOB_DISABLE;
    TPU4.TGRA = _0001_TGRA4_VALUE;
    TPU4.TGRB = _0001_TGRB4_VALUE;

    R_Config_TPU4_Create_UserInit();
}

/***********************************************************************************************************************
* Function Name: R_Config_TPU4_Start
* Description  : This function starts the TPU4 channel counter
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

void R_Config_TPU4_Start(void)
{
    /* Enable TGI4A interrupt in ICU */
    IEN(PERIB, INTB160) = 1U;
    
    /* Start TPU channel 4 counter */
    TPUA.TSTR.BIT.CST4 = 1U;
}

/***********************************************************************************************************************
* Function Name: R_Config_TPU4_Stop
* Description  : This function stops the TPU4 channel counter
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

void R_Config_TPU4_Stop(void)
{
    /* Disable TGI4A interrupt in ICU */
    IEN(PERIB, INTB160) = 0U;
    
    /* Stop TPU channel 4 counter */
    TPUA.TSTR.BIT.CST4 = 0U;
}

/* Start user code for adding. Do not edit comment generated here */

#endif

/* End user code. Do not edit comment generated here */   
